import { world, system, ItemStack, MolangVariableMap } from "@minecraft/server";

system.beforeEvents.watchdogTerminate.subscribe((e) => {
    e.cancel = true
})

world.beforeEvents.playerBreakBlock.subscribe((data) => {
    const inventory = data.player.getComponent("inventory").container
    const item = inventory.getItem(data.player.selectedSlot)
    if (data.block.typeId == "minecraft:mob_spawner" && item != undefined && item.typeId == "nk:obsidian_pickaxe") {
        system.run(() => {
            world.playSound("random.break", data.player.location)
            world.playSound("respawn_anchor.deplete", data.player.location)
            inventory.setItem(data.player.selectedSlot, new ItemStack("minecraft:mob_spawner", 1))
        })
    }
})

world.afterEvents.entityHitBlock.subscribe((data) => {
    const player = data.damagingEntity
    const block = data.hitBlock
    const loc = data.hitBlock.location
    if (block.typeId == "minecraft:end_portal_frame" && player.typeId == 'minecraft:player') {
        const inventory = player.getComponent("inventory").container
        const item = inventory.getItem(data.damagingEntity.selectedSlot)
        if (item != undefined && item.typeId == "nk:obsidian_pickaxe") {
            system.run(() => {
                world.getDimension(player.dimension.id).spawnParticle('minecraft:totem_particle', loc)
                world.playSound("random.break", data.damagingEntity.location)
                inventory.setItem(player.selectedSlot, undefined)
            })
            system.runTimeout(() => {
                world.getDimension(player.dimension.id).fillBlocks(loc, loc, "minecraft:air")
                world.playSound("respawn_anchor.deplete", data.damagingEntity.location)
                inventory.setItem(player.selectedSlot, new ItemStack("minecraft:end_portal_frame", 1))
            },60)
        }
    }
})
